Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/SelfTest/src/test.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/SelfTest/src/test.cpp	(revision 128)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/SelfTest/src/test.cpp	(revision 129)
@@ -30,4 +30,5 @@
 
   simulation_init(0,0,0,false,false);
+  _model.set_model(NAME_Commit_unit, MODEL_SYSTEMC, true);
 
   debug_idle_cycle = CYCLE_MAX;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_genMealy_commit.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_genMealy_commit.cpp	(revision 128)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_genMealy_commit.cpp	(revision 129)
@@ -45,5 +45,5 @@
     for (uint32_t i=0; i<_param->_nb_inst_commit; i++)
       {
-        commit_ack        [i] = false;
+        commit_ack [i] = false;
 
 	// Test if have valid instruction
@@ -51,5 +51,5 @@
 	  {
             // packet_id number can 
-	    Tpacket_t packet_id       = (_param->_have_port_rob_ptr  )?PORT_READ(in_COMMIT_PACKET_ID [i]):0;
+	    Tpacket_t packet_id       = (_param->_have_port_rob_ptr)?PORT_READ(in_COMMIT_PACKET_ID [i]):0;
 	    uint32_t  num_bank        = packet_id & _param->_mask_num_bank;
 	    uint32_t  num_bank_access = bank_nb_access [num_bank];
@@ -59,6 +59,6 @@
 	      {
 		// find
-		bank_nb_access    [num_bank] ++;
-		commit_ack        [i] = true;
+		bank_nb_access  [num_bank] ++;
+		commit_ack      [i] = true;
 
 		internal_BANK_COMMIT_VAL      [num_bank][num_bank_access] = true;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_genMoore.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_genMoore.cpp	(revision 128)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_genMoore.cpp	(revision 129)
@@ -30,5 +30,5 @@
     // ===================================================================
     {
-      uint32_t nb_scan_bank = 0; // last scan bank
+      uint32_t num_scan_bank = 0; // last scan bank
       bool     can_continue = true;
 
@@ -48,7 +48,7 @@
 	  Tcontrol_t val = false;
 
-	  for (uint32_t j=nb_scan_bank; j<_param->_nb_bank; j++)
+	  for (uint32_t j=num_scan_bank; j<_param->_nb_bank; j++)
 	    {
-	      nb_scan_bank ++;
+	      num_scan_bank ++;
 	      
               // translate bank number
@@ -82,4 +82,6 @@
 			    );
 		  
+                  event_nb_inst [front_end_id][context_id] ++;
+
                   can_continue &= (((state == ROB_STORE_OK          ) or
                                     (state == ROB_STORE_OK_WAIT_END ) or
@@ -90,5 +92,5 @@
                                         (reg_EVENT_PACKET[front_end_id][context_id] == num_packet)) and
                                    not ((reg_EVENT_NB_INST [front_end_id][context_id] > 0) and
-                                        ((++event_nb_inst [front_end_id][context_id]) >= reg_EVENT_NB_INST [front_end_id][context_id]))
+                                        ((event_nb_inst [front_end_id][context_id]) >= reg_EVENT_NB_INST [front_end_id][context_id]))
                                    );
 
@@ -129,5 +131,5 @@
       // Branchement must be send at the prediction unit
 
-      uint32_t nb_scan_bank = 0; // last scan bank
+      uint32_t num_scan_bank = 0; // last scan bank
 
       // for each port, find a valid branchement.
@@ -138,7 +140,7 @@
 	  Tcontrol_t  val  = false;
 	  
-	  for (uint32_t j=nb_scan_bank; j<_param->_nb_bank; j++)
+	  for (uint32_t j=num_scan_bank; j<_param->_nb_bank; j++)
 	    {
-	      nb_scan_bank ++;
+	      num_scan_bank ++;
 
               // translate bank number
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/SelfTest/src/test.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/SelfTest/src/test.cpp	(revision 128)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/SelfTest/src/test.cpp	(revision 129)
@@ -18,4 +18,16 @@
   morpheo::behavioural::Parameters_Statistics * _parameters_statistics = new morpheo::behavioural::Parameters_Statistics (5,CYCLE_MAX);
 #endif
+
+  simulation_init(0,0,0,false,false);
+  _model.set_model(NAME_Rename_unit                      , MODEL_SYSTEMC, true);
+  _model.set_model(NAME_Load_Store_pointer_unit          , MODEL_SYSTEMC, true);
+  _model.set_model(NAME_Register_translation_unit        , MODEL_SYSTEMC, true);
+  _model.set_model(NAME_Dependency_checking_unit         , MODEL_SYSTEMC, true);
+  _model.set_model(NAME_Free_List_unit                   , MODEL_SYSTEMC, true);
+  _model.set_model(NAME_Register_Address_Translation_unit, MODEL_SYSTEMC, true);
+  _model.set_model(NAME_Register_translation_unit_Glue   , MODEL_SYSTEMC, true);
+  _model.set_model(NAME_Stat_List_unit                   , MODEL_SYSTEMC, true);
+  _model.set_model(NAME_Rename_select                    , MODEL_SYSTEMC, true);
+  _model.set_model(NAME_Rename_unit_Glue                 , MODEL_SYSTEMC, true);
 
   Tusage_t _usage = USE_ALL;
@@ -386,4 +398,5 @@
   in_NRESET->write(1);  
 
+#ifdef SELFTEST
   LABEL("Loop of Test");
 
@@ -394,4 +407,7 @@
       SC_START(1);
     }
+#else
+  SC_START(1000);
+#endif
 
   /********************************************************
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/SelfTest/debug.cfg
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/SelfTest/debug.cfg	(revision 129)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/SelfTest/debug.cfg	(revision 129)
@@ -0,0 +1,43 @@
+OOO_Engine
+1	1	+1	# nb_front_end                                        
+1	1	+1	# nb_context                        [0]               [nb_front_end]
+1	1	+1	# nb_rename_unit                                      
+1	1	+1	# nb_execute_loop                                     
+1	1	+1	# nb_inst_decod                     [0]               [nb_front_end]
+1	1	+1	# nb_inst_insert                    [0]               [nb_rename_unit]
+1	1	+1	# nb_inst_retire                    [0]               [nb_rename_unit]
+1	1	+1	# nb_inst_execute                   [0]               [nb_execute_loop]
+1	1	+1	# nb_inst_reexecute                                   
+1	1	+1	# nb_inst_commit                                      
+1	1	+1	# nb_inst_branch_complete                             
+1	1	+1	# nb_branch_speculated              [0][0]            [nb_front_end][nb_context]
+1	1	+1	# size_nb_inst_decod  
+1	1	+1	# nb_rename_unit_select                    
+1	1	+1	# nb_execute_loop_select                   
+32	32	*2	# size_general_data                        
+2	2	*2	# size_special_data                        
+0	0	+1	# link_rename_unit_with_front_end   [0]               [nb_front_end]
+1	1	+1	# size_re_order_buffer                     
+1	1	+1	# nb_re_order_buffer_bank                  
+1	1	+1	# commit_priority                          
+1	1	+1	# commit_load_balancing                    
+1	1	+1	# size_issue_queue
+1	1	+1	# issue_queue_scheme
+1	1	+1	# nb_issue_queue_bank                      
+1	1	+1	# issue_priority                           
+1	1	+1	# issue_load_balancing                     
+1	1	+1	# size_reexecute_queue                     
+1	1	+1	# reexecute_priority                       
+1	1	+1	# reexecute_load_balancing                 
+1	1	+1	# rename_select_priority            [0]               [nb_rename_unit]
+1	1	+1	# rename_select_load_balancing      [0]               [nb_rename_unit]
+1	1	+1	# rename_select_nb_front_end_select [0]               [nb_rename_unit]
+64	64	+1	# nb_general_register               [0]               [nb_rename_unit]
+4	4	+1	# nb_special_register               [0]               [nb_rename_unit]
+1	1	+1	# nb_reg_free                       [0]               [nb_rename_unit]
+1	1	+1	# nb_rename_unit_bank               [0]               [nb_rename_unit]
+1	1	+1	# nb_load_store_queue               [0]               [nb_rename_unit]
+2	2	+1	# size_store_queue                  [0][0]            [nb_rename_unit][nb_load_store_queue]
+1	1	+1	# size_load_queue                   [0][0]            [nb_rename_unit][nb_load_store_queue]
+1	1	+1	# nb_inst_memory                    [0][0]            [nb_rename_unit][nb_load_store_queue]
+0	0	+1	# link_load_store_unit_with_thread  [0][0]            [nb_front_end][nb_context]           