Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/src/Functionnal_unit_transition.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/src/Functionnal_unit_transition.cpp	(revision 133)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/src/Functionnal_unit_transition.cpp	(revision 134)
@@ -48,4 +48,20 @@
 		  }
 	      }
+
+        _execute_operation_out->_context_id    = 0; // not necessary
+        _execute_operation_out->_front_end_id  = 0; // not necessary
+        _execute_operation_out->_ooo_engine_id = 0; // not necessary
+        _execute_operation_out->_packet_id     = 0; // not necessary
+  //    _execute_operation_out->_operation     = 0; // not necessary
+  //    _execute_operation_out->_type          = 0; // not necessary
+        _execute_operation_out->_write_rd      = 0; // not necessary
+        _execute_operation_out->_num_reg_rd    = 0; // not necessary
+        _execute_operation_out->_data_rd       = 0; // not necessary
+        _execute_operation_out->_write_re      = 0; // not necessary
+        _execute_operation_out->_num_reg_re    = 0; // not necessary
+        _execute_operation_out->_data_re       = 0; // not necessary
+        _execute_operation_out->_exception     = 0; // not necessary
+        _execute_operation_out->_no_sequence   = 0; // not necessary
+        _execute_operation_out->_address       = 0; // not necessary
       }
     else
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Load_store_unit_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Load_store_unit_allocation.cpp	(revision 133)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Load_store_unit_allocation.cpp	(revision 134)
@@ -179,21 +179,24 @@
 
 #if defined(DEBUG) and defined(DEBUG_Load_store_unit) and (DEBUG_Load_store_unit == true)
-    directory_init ();
-
-    memory_log_file = new std::ofstream [_param->_nb_thread];
-    for (uint32_t i=0; i<_param->_nb_thread; ++i)
-      if (_param->_num_thread_valid [i])
-        {
-          
-          std::string filename = morpheo::filename(MORPHEO_LOG,
-                                                   "Memory_access-thread_"+toString(i),
-                                                   "",
-                                                   "log",
-                                                   _simulation_file_with_date,
-                                                   _simulation_file_with_pid ,
-                                                   true);
-          
-          memory_log_file [i].open(filename.c_str() ,std::ios::out | std::ios::trunc);
-        }
+    if (log_file_generate)
+      {
+	directory_init ();
+	
+	memory_log_file = new std::ofstream [_param->_nb_thread];
+	for (uint32_t i=0; i<_param->_nb_thread; ++i)
+	  if (_param->_num_thread_valid [i])
+	    {
+	      
+	      std::string filename = morpheo::filename(MORPHEO_LOG,
+						       "Memory_access-thread_"+toString(i),
+						       "",
+						       "log",
+						       _simulation_file_with_date,
+						       _simulation_file_with_pid ,
+						       true);
+	      
+	      memory_log_file [i].open(filename.c_str() ,std::ios::out | std::ios::trunc);
+	    }
+      }
 #endif
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Load_store_unit_deallocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Load_store_unit_deallocation.cpp	(revision 133)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Load_store_unit_deallocation.cpp	(revision 134)
@@ -122,12 +122,13 @@
 
 #if defined(DEBUG) and defined(DEBUG_Load_store_unit) and (DEBUG_Load_store_unit == true)
-    {
-      for (uint32_t i=0; i<_param->_nb_thread; ++i)
-        if (_param->_num_thread_valid [i])
-          {
-            memory_log_file [i].close();
-          }
-      delete [] memory_log_file;
-    }
+    if (log_file_generate)
+      {
+	for (uint32_t i=0; i<_param->_nb_thread; ++i)
+	  if (_param->_num_thread_valid [i])
+	    {
+	      memory_log_file [i].close();
+	    }
+	delete [] memory_log_file;
+      }
 #endif
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Load_store_unit_function_speculative_load_commit_transition.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Load_store_unit_function_speculative_load_commit_transition.cpp	(revision 133)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Load_store_unit_function_speculative_load_commit_transition.cpp	(revision 134)
@@ -999,4 +999,5 @@
 
 #if defined(DEBUG) and defined(DEBUG_Load_store_unit) and (DEBUG_Load_store_unit == true)
+		  if (log_file_generate)
 	            {
 	              // log file
@@ -1193,19 +1194,20 @@
 		
 #if defined(DEBUG) and defined(DEBUG_Load_store_unit) and (DEBUG_Load_store_unit == true)
-                {
-                  // log file
-                  Tcontext_t num_thread    = get_num_thread(_load_queue [packet_id]._context_id   , _param->_size_context_id   ,
-                                                            _load_queue [packet_id]._front_end_id , _param->_size_front_end_id ,
-                                                            _load_queue [packet_id]._ooo_engine_id, _param->_size_ooo_engine_id);
-                  
-                  memory_log_file [num_thread] 
-                    << "[" << simulation_cycle() << "] "
-                    << std::hex
-                    << "@ 0x" << std::setfill('0') << std::setw(_param->_size_general_data/4) << _load_queue [packet_id]._address << " -[ Read  ]-> 0x" << std::setfill('0') << std::setw(_param->_size_general_data/4) << _load_queue [packet_id]._rdata << " "
-                    << std::dec
-                    << "{" << toString(_load_queue [packet_id]._operation) << "}";
-                  
-                  memory_log_file [num_thread] << std::endl;
-                }
+		if (log_file_generate)
+		  {
+		    // log file
+		    Tcontext_t num_thread    = get_num_thread(_load_queue [packet_id]._context_id   , _param->_size_context_id   ,
+							      _load_queue [packet_id]._front_end_id , _param->_size_front_end_id ,
+							      _load_queue [packet_id]._ooo_engine_id, _param->_size_ooo_engine_id);
+		    
+		    memory_log_file [num_thread] 
+		      << "[" << simulation_cycle() << "] "
+		      << std::hex
+		      << "@ 0x" << std::setfill('0') << std::setw(_param->_size_general_data/4) << _load_queue [packet_id]._address << " -[ Read  ]-> 0x" << std::setfill('0') << std::setw(_param->_size_general_data/4) << _load_queue [packet_id]._rdata << " "
+		      << std::dec
+		      << "{" << toString(_load_queue [packet_id]._operation) << "}";
+		    
+		    memory_log_file [num_thread] << std::endl;
+		  }
 #endif	    
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod/Instruction/include/Types.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod/Instruction/include/Types.h	(revision 133)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod/Instruction/include/Types.h	(revision 134)
@@ -55,5 +55,5 @@
     Texception_t        _exception         ;
     Tbranch_condition_t _branch_condition  ;
-//     Tcontrol_t          _branch_stack_write;
+//  Tcontrol_t          _branch_stack_write;
     Tcontrol_t          _branch_direction  ;
     Tevent_type_t       _event_type        ;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod/src/Decod_genMealy.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod/src/Decod_genMealy.cpp	(revision 133)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod/src/Decod_genMealy.cpp	(revision 134)
@@ -101,10 +101,33 @@
 		Tgeneral_data_t addr = PORT_READ(in_IFETCH_ADDRESS [x])+y;
 
-		_decod_instruction->_instruction      = PORT_READ(in_IFETCH_INSTRUCTION [x][y]);
-		_decod_instruction->_context_id       = x;
-		_decod_instruction->_address_previous = internal_CONTEXT_ADDRESS_PREVIOUS [x];
-		_decod_instruction->_address          = addr; //Compute the current address
-		_decod_instruction->_address_next     = addr+1;
-		_decod_instruction->_is_delay_slot    = internal_CONTEXT_IS_DELAY_SLOT [x];
+		_decod_instruction->_instruction        = PORT_READ(in_IFETCH_INSTRUCTION [x][y]);
+		_decod_instruction->_context_id         = x;
+		_decod_instruction->_address_previous   = internal_CONTEXT_ADDRESS_PREVIOUS [x];
+		_decod_instruction->_address            = addr; //Compute the current address
+		_decod_instruction->_address_next       = addr+1;
+		_decod_instruction->_is_delay_slot      = internal_CONTEXT_IS_DELAY_SLOT [x];
+		_decod_instruction->_type               = 0; // not necessary
+		_decod_instruction->_operation          = 0; // not necessary
+		_decod_instruction->_no_execute         = 0; // not necessary
+		_decod_instruction->_has_immediat       = 0; // not necessary
+		_decod_instruction->_immediat           = 0; // not necessary
+		_decod_instruction->_read_ra            = 0; // not necessary
+		_decod_instruction->_num_reg_ra         = 0; // not necessary
+		_decod_instruction->_read_rb            = 0; // not necessary
+		_decod_instruction->_num_reg_rb         = 0; // not necessary
+		_decod_instruction->_read_rc            = 0; // not necessary
+		_decod_instruction->_num_reg_rc         = 0; // not necessary
+		_decod_instruction->_write_rd           = 0; // not necessary
+		_decod_instruction->_num_reg_rd         = 0; // not necessary
+		_decod_instruction->_write_re           = 0; // not necessary
+		_decod_instruction->_num_reg_re         = 0; // not necessary
+		_decod_instruction->_exception_use      = EXCEPTION_USE_NONE; // not necessary
+		_decod_instruction->_exception          = EXCEPTION_DECOD_NONE; // not necessary
+		_decod_instruction->_branch_condition   = 0; // not necessary
+// 		_decod_instruction->_branch_stack_write = 0; // not necessary
+		_decod_instruction->_branch_direction   = 0; // not necessary
+		_decod_instruction->_event_type         = EVENT_TYPE_NONE; // not necessary
+		
+
 
                 // Test IFetch exception
@@ -181,4 +204,5 @@
                 // Branch predictor can accept : the depth is valid
                 log_printf(TRACE,Decod,FUNCTION,"      * context_depth_val      : %d",PORT_READ(in_CONTEXT_DEPTH_VAL [x]));
+
                 decod_val   [i]    &= PORT_READ(in_CONTEXT_DEPTH_VAL [x]);
                 ifetch_ack  [x][y] &= PORT_READ(in_CONTEXT_DEPTH_VAL [x]);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_allocation.cpp	(revision 133)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_allocation.cpp	(revision 134)
@@ -248,20 +248,23 @@
 
 #if defined(DEBUG) and defined(DEBUG_Update_Prediction_Table) and (DEBUG_Update_Prediction_Table == true)
-    directory_init ();
-
-    branchement_log_file = new std::ofstream [_param->_nb_thread];
-    for (uint32_t i=0; i<_param->_nb_thread; ++i)
-      if (_param->_have_thread [i])
-        {
-          std::string filename = morpheo::filename(MORPHEO_LOG,
-                                                   "Branchement_prediction-thread_"+toString(i),
-                                                   "",
-                                                   "log",
-                                                   _simulation_file_with_date,
-                                                   _simulation_file_with_pid,
-                                                   true);
-          
-          branchement_log_file [i] .open(filename.c_str() ,std::ios::out | std::ios::trunc);
-        }
+    if (log_file_generate)
+      {
+	directory_init ();
+	
+	branchement_log_file = new std::ofstream [_param->_nb_thread];
+	for (uint32_t i=0; i<_param->_nb_thread; ++i)
+	  if (_param->_have_thread [i])
+	    {
+	      std::string filename = morpheo::filename(MORPHEO_LOG,
+						       "Branchement_prediction-thread_"+toString(i),
+						       "",
+						       "log",
+						       _simulation_file_with_date,
+						       _simulation_file_with_pid,
+						       true);
+	      
+	      branchement_log_file [i] .open(filename.c_str() ,std::ios::out | std::ios::trunc);
+	    }
+      }
 #endif
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_deallocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_deallocation.cpp	(revision 133)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_deallocation.cpp	(revision 134)
@@ -172,12 +172,13 @@
 
 #if defined(DEBUG) and defined(DEBUG_Update_Prediction_Table) and (DEBUG_Update_Prediction_Table == true)
-    {
-      for (uint32_t i=0; i<_param->_nb_thread; ++i)
-        if (_param->_have_thread [i])
-          {
-            branchement_log_file [i].close();
-          }
-      delete [] branchement_log_file;
-    }
+    if (log_file_generate)
+      {
+	for (uint32_t i=0; i<_param->_nb_thread; ++i)
+	  if (_param->_have_thread [i])
+	    {
+	      branchement_log_file [i].close();
+	    }
+	delete [] branchement_log_file;
+      }
 #endif
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_transition.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_transition.cpp	(revision 133)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_transition.cpp	(revision 134)
@@ -149,19 +149,20 @@
                     {
 #if defined(DEBUG) and defined(DEBUG_Update_Prediction_Table) and (DEBUG_Update_Prediction_Table == true)
-                      if (reg_UPDATE_PREDICTION_TABLE [i][bottom]._retire_ok)
-                        {
-                          uint32_t num_thread = _param->_translate_num_context_to_num_thread [i];
-                          branchement_log_file [num_thread] 
-                            << std::hex
-                            << "0x" << std::setfill('0') << std::setw(_param->_size_general_data/4) << reg_UPDATE_PREDICTION_TABLE [i][bottom]._address_src  << " "
-                            << "0x" << std::setfill('0') << std::setw(_param->_size_general_data/4) << reg_UPDATE_PREDICTION_TABLE [i][bottom]._address_dest << " "
-                            << std::dec
-                            <<         reg_UPDATE_PREDICTION_TABLE [i][bottom]._good_take         << " - "
-                            << "["  << simulation_cycle() << "] " << " "
-                            <<         reg_UPDATE_PREDICTION_TABLE [i][bottom]._miss_prediction   << " "
-                            <<         reg_UPDATE_PREDICTION_TABLE [i][bottom]._ifetch_prediction << " "
-                            << "("  << toString(reg_UPDATE_PREDICTION_TABLE [i][bottom]._condition) << ")"
-                            << std::endl;
-                        }
+		      if (log_file_generate)
+			if (reg_UPDATE_PREDICTION_TABLE [i][bottom]._retire_ok)
+			  {
+			    uint32_t num_thread = _param->_translate_num_context_to_num_thread [i];
+			    branchement_log_file [num_thread] 
+			      << std::hex
+			      << "0x" << std::setfill('0') << std::setw(_param->_size_general_data/4) << reg_UPDATE_PREDICTION_TABLE [i][bottom]._address_src  << " "
+			      << "0x" << std::setfill('0') << std::setw(_param->_size_general_data/4) << reg_UPDATE_PREDICTION_TABLE [i][bottom]._address_dest << " "
+			      << std::dec
+			      <<         reg_UPDATE_PREDICTION_TABLE [i][bottom]._good_take         << " - "
+			      << "["  << simulation_cycle() << "] " << " "
+			      <<         reg_UPDATE_PREDICTION_TABLE [i][bottom]._miss_prediction   << " "
+			      <<         reg_UPDATE_PREDICTION_TABLE [i][bottom]._ifetch_prediction << " "
+			      << "("  << toString(reg_UPDATE_PREDICTION_TABLE [i][bottom]._condition) << ")"
+			      << std::endl;
+			  }
 #endif
                       
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_allocation.cpp	(revision 133)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_allocation.cpp	(revision 134)
@@ -358,21 +358,24 @@
 
 #if defined(DEBUG) and defined(DEBUG_Commit_unit) and (DEBUG_Commit_unit == true)
-    directory_init ();
-
-    instruction_log_file = new std::ofstream [_param->_nb_thread];
-    for (uint32_t i=0; i<_param->_nb_thread; ++i)
-      if (_param->_have_thread [i])
-        {
-          
-          std::string filename = morpheo::filename(MORPHEO_LOG,
-                                                   "Instruction_flow-thread_"+toString(i),
-                                                   "",
-                                                   "log",
-                                                   _simulation_file_with_date,
-                                                   _simulation_file_with_pid ,
-                                                   true);
-          
-          instruction_log_file [i].open(filename.c_str() ,std::ios::out | std::ios::trunc);
-        }
+    if (log_file_generate)
+      {
+	directory_init ();
+	
+	instruction_log_file = new std::ofstream [_param->_nb_thread];
+	for (uint32_t i=0; i<_param->_nb_thread; ++i)
+	  if (_param->_have_thread [i])
+	    {
+	      
+	      std::string filename = morpheo::filename(MORPHEO_LOG,
+						       "Instruction_flow-thread_"+toString(i),
+						       "",
+						       "log",
+						       _simulation_file_with_date,
+						       _simulation_file_with_pid ,
+						       true);
+	      
+	      instruction_log_file [i].open(filename.c_str() ,std::ios::out | std::ios::trunc);
+	    }
+      }
 #endif
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_deallocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_deallocation.cpp	(revision 133)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_deallocation.cpp	(revision 134)
@@ -239,12 +239,13 @@
 
 #if defined(DEBUG) and defined(DEBUG_Commit_unit) and (DEBUG_Commit_unit == true)
-    {   
-      for (uint32_t i=0; i<_param->_nb_thread; ++i)
-        if (_param->_have_thread [i])
-          {
-            instruction_log_file [i].close();
-          }
-      delete [] instruction_log_file;
-    }
+    if (log_file_generate)
+      {   
+	for (uint32_t i=0; i<_param->_nb_thread; ++i)
+	  if (_param->_have_thread [i])
+	    {
+	      instruction_log_file [i].close();
+	    }
+	delete [] instruction_log_file;
+      }
 #endif
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_transition.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_transition.cpp	(revision 133)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_transition.cpp	(revision 134)
@@ -831,19 +831,20 @@
 
 #if defined(DEBUG) and defined(DEBUG_Commit_unit) and (DEBUG_Commit_unit == true)
-	            {
-	              // log file
-	              instruction_log_file [num_thread] 
-	            	<< "[" << simulation_cycle() << "] "
-	            	<< std::hex
-	            	<< (entry->address<<2) << " (" << (entry->address) << ") "
-	            	<< std::dec
-	            	<< "[" << entry->cycle_rob_in << ", " << entry->cycle_commit << "] "
-	            	<< "{" << ((retire_ok)?"OK":"KO") << "} ";
-	              
-	              if ((type == TYPE_MEMORY) and  is_operation_memory_load(entry->operation))
-	            	instruction_log_file [num_thread] << std::hex << entry->load_data << std::dec;
-	              
-	              instruction_log_file [num_thread] << std::endl;
-	            }
+		    if (log_file_generate)
+		      {
+			// log file
+			instruction_log_file [num_thread] 
+			  << "[" << simulation_cycle() << "] "
+			  << std::hex
+			  << (entry->address<<2) << " (" << (entry->address) << ") "
+			  << std::dec
+			  << "[" << entry->cycle_rob_in << ", " << entry->cycle_commit << "] "
+			  << "{" << ((retire_ok)?"OK":"KO") << "} ";
+			
+			if ((type == TYPE_MEMORY) and  is_operation_memory_load(entry->operation))
+			  instruction_log_file [num_thread] << std::hex << entry->load_data << std::dec;
+			
+			instruction_log_file [num_thread] << std::endl;
+		      }
 #endif	    
 